<?php

function gera_thumb($imagem,$formato,$altura,$largura)
{
	$thumb = explode("_", $imagem);
	$thumb = $thumb[0]."_thumb.".$formato;

	if ($formato == "gif")
   		$img_origem = ImageCreateFromGIF($imagem);
			else
				$img_origem = ImageCreateFromJPEG($imagem);

	$origem_x = imagesx($img_origem);
	$origem_y = imagesy($img_origem);

	$x = $largura;
	$y = $altura;
   
	$final_x = floor($y * $origem_x / $origem_y);
	$final_y = floor($x * $origem_x / $origem_y);

	$f_x = round(($x / 2) - ($final_x / 2));
	$f_y = round(($y / 2) - ($final_y / 2));

    $img_final = ImageCreateTrueColor($x,$y);

    ImageCopyResized($img_final, $img_origem, $f_x, $f_y, 0, 0, $final_x, $final_y, $origem_x, $origem_y);
	
	if ($formato == "gif")
		ImageGIF($img_final, $thumb);
			else
				ImageJPEG($img_final, $thumb);
	
    ImageDestroy($img_origem);
    ImageDestroy($img_final);
	
	return $thumb;
}
?>